# $Id$
package Data::Squirrel::Store::DBI;

use strict;
use vars qw(@ISA);
use Apache::Session::Store::DBI;
sub DEBUG {0}
use Data::Dumper;
@ISA=qw(Apache::Session::Store::DBI);

sub exists
{
    my($self, $squirrel) = @_;
 
    $self->connection($squirrel);

    if (!defined $self->{exists_sth}) {
        $self->{exists_sth} = 
            $self->{dbh}->prepare_cached(qq{
                SELECT id FROM sessions WHERE id = ?});
    }
    DEBUG and warn "Want to see if $squirrel->{data}{_session_id} exists\n";

    $self->{exists_sth}->bind_param(1, $squirrel->{data}->{_session_id});
    $self->{exists_sth}->execute;
    my $results = $self->{exists_sth}->fetchrow_arrayref;
#    use Data::Dumper;
#    warn Dumper $results;
    $self->{exists_sth}->finish;
    DEBUG and warn "It does", ($results ? "\n" : "n't\n");
    return $results;
}

sub list_ids
{
    my($self, $squirrel) = @_;
 
    $self->connection($squirrel);

    if (!defined $self->{list_sth}) {
        $self->{list_sth} = 
            $self->{dbh}->prepare_cached(qq{SELECT id FROM sessions});
    }

    $self->{list_sth}->execute;

    local $squirrel->{data}={};
    my($results, @ids);
    while(defined($results = $self->{list_sth}->fetchrow_arrayref)) {
        DEBUG and warn "Validating $results->[0]\n";
        $squirrel->{data}{_session_id}=$results->[0];
        eval {$squirrel->{validate}->($squirrel)};
        DEBUG and $@ and warn $@;
        next if $@;
        DEBUG and warn "It's an object ID";
        push @ids, $results->[0];
    }
    $self->{list_sth}->finish;
    return @ids if wantarray;
    return \@ids;
}

1;

__END__

=pod

=head1 NAME

Data::Squirrel::Store::DBI - Wrapper around Apache::Session::Store::DBI

=head1 SYNOPSIS

=head1 DESCRIPTION

This is a root class upon with Data::Squirrel::Store::MySQL is based.  You should
also use it to implement Data::Squirrel::Store::Postgres.

=head1 AUTHOR

Philip Gwyn

=head1 SEE ALSO

L<Apache::Session::Store::DBI>


=cut


$Log$
