# $Id$

package Data::Squirrel::Store::DB_File;
use strict;

use DB_File;
use Apache::Session::Store::DB_File;

use vars qw(@ISA);
@ISA=qw(Apache::Session::Store::DB_File);

#########################################################
sub remove
{
    my($self, $squirrel) = @_;

    eval {$self->SUPER::remove($squirrel);};
    warn $@ if $@;
}

#########################################################
sub exists
{
    my($self, $squirrel) = @_;
    
    if (!tied %{$self->{dbm}}) {
        my $rv = tie %{$self->{dbm}}, 'DB_File', $squirrel->{args}{FileName};
        die "Could not open dbm file: $!" unless $rv;
    }
    return defined $self->{dbm}{$squirrel->{data}{_session_id}};
}

#########################################################
sub list_ids
{
    my($self, $squirrel) = @_;
    
    if (!tied %{$self->{dbm}}) {
        my $rv = tie %{$self->{dbm}}, 'DB_File', $squirrel->{args}->{FileName};
        die "Could not open dbm file: $!" unless $rv;
    }
    my @ids=keys %{$self->{dbm}};
    return @ids if wantarray;
    return \@ids;
}


1;

__END__

=pod

=head1 NAME

Data::Squirrel::Store::DB_File - Wrapper around Apache::Session::Store::DB_File

=head1 SYNOPSIS



=head1 DESCRIPTION

Data::Squirrel::Store::DB_File fulfills the storage interface of
Data::Squirrel. Data is squirreled away in Berkely DB files.

Go read L<Apache::Session::Store::DB_File> for information about
configuration.

=head1 AUTHOR

Philip Gwyn

=head1 SEE ALSO

L<Apache::Session::Store::DB_File>


=cut


$Log$
