# $Id$

package Data::Squirrel::Store::File;
use strict;

use strict;

use Apache::Session::Store::File;
use vars qw(@ISA);
@ISA=qw(Apache::Session::Store::File);

#########################################################
sub remove
{
    my($self, $squirrel) = @_;

    eval {$self->SUPER::remove($squirrel);};
    warn $@ if $@;
    $self->close();
}

#########################################################
sub exists
{
    my($self, $squirrel) = @_;
    
    my $directory = $squirrel->{args}->{Directory} || $Apache::Session::Store::File::Directory;
    die "The directory for object storage must be passed as an argument or set in httpd.conf" 
        unless defined $directory;
#    warn "Looking for $directory/$squirrel->{data}->{_session_id}\n";
    return -e $directory.'/'.$squirrel->{data}->{_session_id};
}

#########################################################
sub insert
{
    my($self, $s)=@_;
    my $r=$self->SUPER::insert($s);
    $self->close();
    return $r;
}

#########################################################
sub update
{
    my($self, $s)=@_;
    my $r=$self->SUPER::update($s);
    $self->close();
    return $r;
}

#########################################################
sub materialize
{
    my($self, $s)=@_;
    my $r=$self->SUPER::materialize($s);
    $self->close();
    return $r;
}

1;

__END__

=pod

=head1 NAME

Data::Squirrel::Store::File - Wrapper around Apache::Session::Store::File

=head1 SYNOPSIS



=head1 DESCRIPTION

Data::Squirrel::Store::File fulfills the storage interface of
Data::Squirrel. Data is squirreled away in files on your disks.

Go read L<Apache::Session::Store::File> for information about configuration.

=head1 AUTHOR

Philip Gwyn

=head1 SEE ALSO

L<Apache::Session::Store::File>


=cut

$Log$
